package com.bureau.devicefingerprint.tools

import org.json.JSONArray
import org.json.JSONException
import org.json.JSONObject
import java.util.TreeMap

object JSONUtils {
    @Throws(JSONException::class)
    fun jsonToMap(json: String): MutableMap<String, Any> {
        val jsonObject = JSONObject(json)
        return _jsonToMap_(jsonObject)
    }

    @Throws(JSONException::class)
    private fun _jsonToMap_(json: JSONObject): MutableMap<String, Any> {
        var retMap: MutableMap<String, Any> = TreeMap()
        if (json != JSONObject.NULL) {
            retMap = toMap(json)
        }
        return retMap
    }

    @Throws(JSONException::class)
    private fun toMap(`object`: JSONObject): MutableMap<String, Any> {
        val map: MutableMap<String, Any> = TreeMap()
        val keysItr = `object`.keys()
        while (keysItr.hasNext()) {
            val key = keysItr.next()
            var value = `object`[key]
            if (value is JSONArray) {
                value = toList(value)
            } else if (value is JSONObject) {
                value = toMap(value)
            }
            map[key] = value
        }
        return map
    }

    @Throws(JSONException::class)
    fun toList(array: JSONArray): List<Any> {
        val list: MutableList<Any> = ArrayList()
        for (i in 0 until array.length()) {
            var value = array[i]
            if (value is JSONArray) {
                value = toList(value)
            } else if (value is JSONObject) {
                value = toMap(value)
            }
            list.add(value)
        }
        return list
    }
}
